#ifndef __FOURIER_H__
#define __FOURIER_H__

#include "math.h"
#define MAX 100
#define PI 3.1415926535897932385
#define PI2 PI*2
typedef struct{	double r, i;}complex;
complex ExpJ(double A){
	complex r; r.r=cos(A);r.i=sin(A); return r;
}
complex add(complex A, complex B){
	complex r; r.r=A.r+B.r; r.i=A.i+B.i; return r;
}
complex mlt(complex A, complex B){
	complex r;
	r.r=A.r*B.r-A.i*B.i;
	r.i=A.r*B.i+A.i*B.r; return r;
}
complex setC(double A, double B){
	complex r;r.r=A; r.i=B; return r;
}
complex divR(complex A, double B){
	complex r; r.r=A.r/B; r.i=A.i/B; return r;
}
void DFT(complex X[],complex Y[], int max){
	for(int k=0;k<max;k++){
		Y[k]=setC(0,0);
		for(int n=0;n<max;n++)
			Y[k]=add(Y[k],mlt(X[n], ExpJ(-PI2*n*k/max)));
	}
	Y[max]=Y[0];
}
void IDFT(complex Y[],complex X[], int max){
	for(int k=0;k<max;k++){
		X[k]=setC(0,0);
		for(int n=0;n<max;n++)
			X[k]=add(X[k],mlt(Y[n], ExpJ(PI2*n*k/max)));
	}
	for(int k=0;k<max;k++)X[k]=divR(X[k],max);
	X[max]=X[0];
}
#endif
